package com.ruoyi.zdsz.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.annotation.DynamicName;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.zdsz.domain.ZEngineeringNode;
import com.ruoyi.zdsz.domain.bo.ZEngineeringNodeBo;
import com.ruoyi.zdsz.domain.vo.ZEngineeringCivilVo;
import com.ruoyi.zdsz.domain.vo.ZEngineeringNodeVo;
import com.ruoyi.zdsz.service.IZEngineeringNodeService;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.zdsz.domain.bo.ZEngineeringPipeJackingBo;
import com.ruoyi.zdsz.domain.vo.ZEngineeringPipeJackingVo;
import com.ruoyi.zdsz.domain.ZEngineeringPipeJacking;
import com.ruoyi.zdsz.mapper.ZEngineeringPipeJackingMapper;
import com.ruoyi.zdsz.service.IZEngineeringPipeJackingService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 顶管工程Service业务层处理
 *
 * @author ruoyi
 * @date 2024-01-02
 */
@RequiredArgsConstructor
@Service
public class ZEngineeringPipeJackingServiceImpl implements IZEngineeringPipeJackingService {

    private final ZEngineeringPipeJackingMapper baseMapper;

    @Autowired
    private IZEngineeringNodeService nodeService;

    /**
     * 查询顶管工程
     */
    @Override
    public ZEngineeringPipeJackingVo queryById(String id){
        ZEngineeringPipeJackingVo jackingVo = baseMapper.selectVoById(id);
        ZEngineeringNodeBo bo = new ZEngineeringNodeBo();
        bo.setCreateTime(jackingVo.getCreateTime());
        bo.setCivliId(jackingVo.getId());
        jackingVo.setZEngineeringNodeBoList(nodeService.queryListDetails(bo));
        return jackingVo;
    }

    /**
     * 查询顶管工程列表
     */
    @Override
    public TableDataInfo<ZEngineeringPipeJackingVo> queryPageList(ZEngineeringPipeJackingBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = buildQueryWrapper(bo);
        Page<ZEngineeringPipeJackingVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询顶管工程列表
     */
    @Override
    public List<ZEngineeringPipeJackingVo> queryList(ZEngineeringPipeJackingBo bo) {
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ZEngineeringPipeJacking> buildQueryWrapper(ZEngineeringPipeJackingBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ZEngineeringPipeJacking> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getEnginId()), ZEngineeringPipeJacking::getEnginId, bo.getEnginId());
        lqw.like(StringUtils.isNotBlank(bo.getEnginName()), ZEngineeringPipeJacking::getEnginName, bo.getEnginName());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginAddre()), ZEngineeringPipeJacking::getEnginAddre, bo.getEnginAddre());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginCode()), ZEngineeringPipeJacking::getEnginCode, bo.getEnginCode());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructUnit()), ZEngineeringPipeJacking::getConstructUnit, bo.getConstructUnit());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginScale()), ZEngineeringPipeJacking::getEnginScale, bo.getEnginScale());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructQuality()), ZEngineeringPipeJacking::getConstructQuality, bo.getConstructQuality());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructSchedule()), ZEngineeringPipeJacking::getConstructSchedule, bo.getConstructSchedule());
        return lqw;
    }

    /**
     * 新增顶管工程
     */
    @Transactional(rollbackFor=Exception.class)
    @Override
    public Boolean insertByBo(ZEngineeringPipeJackingBo bo) {
        ZEngineeringPipeJacking add = BeanUtil.toBean(bo, ZEngineeringPipeJacking.class);
        validEntityBeforeSave(add);
        //民用
        if (bo.getType()==1){
            List<Map<String, Object>> civil = baseMapper.getCivil(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        //工业市政
        else if(bo.getType()==2){
        }
        // 危险
        else if(bo.getType()==3){
            List<Map<String, Object>> civil = baseMapper.getDangerous(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginName((String) civil.get(0).get("name"));
                add.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        //基建
        else if(bo.getType()==4){
            List<Map<String, Object>> civil = baseMapper.getInfrastructure(bo.getEnginId());
            if (!civil.isEmpty()){
                add.setEnginName((String) civil.get(0).get("name"));
                add.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
            bo.getzEngineeringNodeBo().setCivliId(add.getId());
            bo.getzEngineeringNodeBo().setCreateTime(bo.getCreateTime());
            nodeService.insert(bo.getzEngineeringNodeBo());
        }
        return flag;
    }

    /**
     * 修改顶管工程
     */
    @Override
    @Transactional(rollbackFor=Exception.class)
    public Boolean updateByBo(ZEngineeringPipeJackingBo bo) {
        ZEngineeringPipeJacking update = BeanUtil.toBean(bo, ZEngineeringPipeJacking.class);
        validEntityBeforeSave(update);
        //民用
        if (bo.getType()==1){
            List<Map<String, Object>> civil = baseMapper.getCivil(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginAddre((String) civil.get(0).get("name"));
            }
        }
        //工业市政
        else if(bo.getType()==2){
        }
        // 危险
        else if(bo.getType()==3){
            List<Map<String, Object>> civil = baseMapper.getDangerous(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginName((String) civil.get(0).get("name"));
                update.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        //基建
        else if(bo.getType()==4){
            List<Map<String, Object>> civil = baseMapper.getInfrastructure(bo.getEnginId());
            if (!civil.isEmpty()){
                update.setEnginName((String) civil.get(0).get("name"));
                update.setEnginAddre((String) civil.get(0).get("address"));
            }
        }
        bo.getzEngineeringNodeBo().setCivliId(bo.getId());
        bo.getzEngineeringNodeBo().setCreateTime(bo.getCreateTime());
        nodeService.update(bo.getzEngineeringNodeBo());
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ZEngineeringPipeJacking entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除顶管工程
     */
    @Override
    @Transactional(rollbackFor=Exception.class)
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        ids.forEach(item -> {
            ZEngineeringPipeJackingVo vo = baseMapper.selectVoById(item);
            ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
            zEngineeringNodeBo.setCreateTime(vo.getCreateTime());
            zEngineeringNodeBo.setCivliId(vo.getId());
            List<ZEngineeringNodeBo> zEngineeringNodeBos = nodeService.queryListDetails(zEngineeringNodeBo);
            zEngineeringNodeBos.stream().forEach(ite ->
                nodeService.delete(ite)
            );
        });
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
